Page({
    data: {
        radius: 200,
        deviceId: 'vdevo166806201045463',
        modalFlag: false,
        addFlag: true,
        dpCodes: {
            bright_value: 500,
            colour_data: "",
            switch_led: true,
            temp_value: 750,
            work_mode: "white"
        },
        colorArr: [
            { temp_value: 100, bright_value: 100, color: '#CEEDFE', active: false },
            { temp_value: 200, bright_value: 200, color: '#F5FCFF', active: false },
            { temp_value: 300, bright_value: 300, color: '#FFE2A4', active: false }
        ],
        schema: {},
        tempProps: {
            value: 0,
            min: 0,
            max: 1000,
            minRangeValue: 0,
            maxRangeValue: 1000,
            thumbSize: 40,
            touchThumbSize: 40,
            offsetAngle: 45,
            innerRadius: 88,
            outerRadius: 120,
            wrapperStyle: null,
            stopColors: [],
            thumbStyle: null,
            disabled: false,
            showThumb: false,
            renderThumb: null,
            renderTrack: null,

            thumbX: 68,
            thumbY: 110
        }
    },

    changeEventGen: function (e) {
        console.log(e, 'Event')
        const value = e.detail.value
        const dpId = this.data.schema[e.target.id]['id']
        const key = 'dpCodes.' + e.target.id
        this.setData({
            [key]: value
        })
        console.log(this.data)
        this.changeState(dpId, value)
    },

    togglePan: function () {
        const flag = !this.data.dpCodes.switch_led
        const dpId = this.data.schema.switch_led.id
        this.setData({
            'dpCodes.switch_led': flag
        })
        this.changeState(dpId, flag)
    },

    changeState: async function (dpId, value) {
        // const info = ty.getLaunchOptionsSync()
        ty.device.publishDps({
            deviceId: this.data.deviceId,
            dps: {
                [dpId]: value,
            },
            mode: 2,
            success: function (res) {
                console.log(res, 'res')
            }
        })
    },

    addColorFn: function () {
        if (this.data.colorArr.length > 5) {
            this.setData({
                addFlag: false
            })
            return
        }
        let arr = this.data.colorArr
        const item = {
            temp_value: this.data.dpCodes.temp_value,
            bright_value: this.data.dpCodes.bright_value,
            color: '#FFFFFF',
            active: false
        }
        const flag = arr.some((el) => {
            return (item.bright_value == el.bright_value && item.temp_value == el.temp_value)
        })

        if (flag) {
            this.setData({
                modalFlag: true
            })
            return
        }

        arr.push(item)
        this.setData({
            colorArr: arr
        })
    },

    deleteColorFn: function (e) {
        console.log(e, 'de')
        const el = e.target.dataset.item
        const index = this.data.colorArr.findIndex((item) => {
            return item.active == true
        })
        let data = this.data.colorArr
        data.splice(index, 1)
        this.setData({
            colorArr: data
        })
        if (this.data.colorArr.length < 6) {
            this.setData({
                addFlag: true
            })
        }
    },

    cancelModalFlag: function () {
        this.setData({
            modalFlag: false
        })
    },

    cirleClick: function (e) {
        console.log(e, 'cl')
        const data = this.data.colorArr
        for (let i = 0; i < data.length; i++) {
            data[i]['active'] = false
        }
        this.setData({
            colorArr: data
        })
        const el = e.target.dataset.item
        const index = this.data.colorArr.findIndex((item) => {
            return (item.bright_value == el.bright_value && item.temp_value == el.temp_value)
        })
        let item = el
        item.active = true
        const str = 'colorArr' + '[' + index + ']'
        this.setData({
            [str]: item
        })
        ty.device.publishDps({
            deviceId: this.data.deviceId,
            dps: {
                22: el.bright_value,
                23: el.temp_value
            },
            mode: 2,
            success: function (res) {
                console.log(res, 'res')
            }
        })
    },
    // getQuery: function () {
    //     // ty.device.queryDps({
    //     //     deviceId: this.data.deviceId,
    //     //     dpIds: [20, 21, 22, 23],
    //     //     success: function (res) {
    //     //         console.log(res, 'queryres')
    //     //     }
    //     // })
    //    console.log(hsv2rgba(200,500,500),'hsv') 
    // },

    controlTemp: function (e) {
        console.log(e)
    },

    onLoad: function () {
        let that = this
        ty.getLaunchOptions({
            success: function (res) {
                that.setData({
                    deviceId: res.query.deviceId
                })
                console.log(res, 'query')
                ty.device.getDeviceInfo({
                    deviceId: res.query.deviceId,
                    success: function (res) {
                        const data = {}
                        res.schema.forEach(el => {
                            data[el.code] = el
                        });
                        that.setData({
                            schema: data
                        })
                        console.log(that.data.schema, 'Phoneres')
                    }
                })
            }
        })
    }
})